<template lang="pug">
.catalog.container
  h1.main-heading Каталог товаров

  .categories__wrapper(v-if='data.data.products.length')

    app-category-link(
      :category="allCategory"
      :activeLink="true"
      :noLink="true")

    app-category-link(
      v-for="category in data.data.categories"
      :category="category"
      :key="category.id")

  el-breadcrumb(separator-class='el-icon-arrow-right')
    el-breadcrumb-item(:to="{ path: '/' }") Главная
    el-breadcrumb-item Каталог товаров

  p(v-if='!data.data.products.length') Нет доступных товаров.

  .row(v-if='data.data.products.length')

    app-product-item.col-xl-4.col-md-6.col-sm-12.mb-40(
      v-for="product in data.data.products"
      :key="product.id"
      :cover="product.photo"
      :heading="product.name"
      :slug="product.slug"
      :composition="product.composition")

  .activity__block(v-if='data.pagination && data.pagination.totalPageCount > data.pagination.perPage')
    el-pagination.public-pagination(
      layout='prev, pager, next'
      @current-change='changePage'
      :current-page="data.pagination.currentPage"
      :page-size='data.pagination.perPage'
      :total='data.pagination ? data.pagination.totalPageCount : 0'
      background)

</template>

<script>
import { mapGetters, mapMutations } from 'vuex';

import CategoriesLink from '../../components/public/CategoriesLink';
import ProductItem from '../../components/public/ProductItem';

export default {
  name: 'Catalog',
  components: {
    'app-category-link': CategoriesLink,
    'app-product-item': ProductItem
  },
  head() {
    return {
      title: 'Каталог товаров | АО «Шувалово»'
    };
  },
  async asyncData({ app, store, params }) {
    let { data } = await app.$axios.get('/api/v1/products/public', {
      params: {
        pagination: {
          perPage: 18,
          currentPage: 1
        }
      }
    });
    return { data: data };
  },
  data() {
    return {
      allCategory: {
        name: 'Все категории',
        slug: ''
      },
      page: 1,
      perPage: 18
    };
  },
  computed: {
    ...mapGetters({
      categories: 'CATEGORIES'
    })
  },
  mounted() {
    if (!this.categories) {
      this.getCategories();
    }
    this.SET_LOADING(false);
  },
  methods: {
    ...mapMutations(['SET_CATEGORIES', 'SET_LOADING']),
    changePage(value) {
      this.page = value;
      this.SET_LOADING(true);
      this.$axios
        .get('/api/v1/products/public', {
          params: {
            pagination: {
              perPage: this.perPage,
              currentPage: value
            }
          }
        })
        .then(data => {
          this.data = data.data;
          this.SET_LOADING(false);
          window.scrollTo(0, 0);
        });
    },
    getCategories() {
      this.$axios.get('/api/v1/categories/public').then(data => {
        this.SET_CATEGORIES(data.data);
      });
    }
  }
};
</script>
